class Proxy {

    constructor(json) {
        if (!json) {
            throw new Error("data is error");
        }
        else {
            this.datas = json;
            this.cart_list = json.cart_list;
            this.bundling_list = json.bundling;
        }
        this.tags = new Map();
    }

    setTag(key, value) {
        this.tags.set(key, value);
    }

    getTag(key) {
        return this.tags.get(key)
    }


    static getGoodsSwiperList(list) {
        if (!Array.isArray(list)) {
            return false;
        }
        else {
            let SwiperList = [];
            let items = list;
            for (let i = 0; i < items.length; i++) {
                let item = {};
                item['img'] = items[i];
                item['src'] = '#/';
                SwiperList.push(item);
            }
            return SwiperList;
        }
    }

    getCart(cart_id) {
        for (let i = 0; i < this.cart_list.length; i++) {
            if (this.cart_list[i].cart_id == cart_id)
                return this.cart_list[i];
        }
    }

    getBundling(bl_id) {
        for (let i = 0; i < this.bundling_list.length; i++) {
            if (this.bundling_list[i].bl_id == bl_id) {
                return this.bundling_list[i];
            }
        }
    }

    getSummery(goods_id) {
        for (let i = 0; i < this.datas.summary.length; i++) {
            let summery = this.datas.summary[i];
            if (summery['goods_id'] == goods_id) {
                return summery;
            }
        }
    }

    getGroupbuy(groupbuy_id) {
        for (let i = 0; i < this.datas.groupbuy.length; i++) {
            let groupbuy = this.datas.groupbuy[i];
            if (groupbuy['groupbuy_id'] == groupbuy_id) {
                return groupbuy;
            }
        }
    }

    getFcode(fcode_id) {
        for (let i = 0; i < this.datas.fcodes.length; i++) {
            let fode = this.datas.fcodes[i];
            if (fode['fcode_id'] == fcode_id) {
                return fode;
            }
        }
    }

}

export default Proxy



