/**
 * Created by huanggang on 2017/5/26.
 */
import Vue from 'vue'
import {WechatPlugin} from 'vux'
Vue.use(WechatPlugin);

class WechatShare {

    constructor(shareData) {
        this.url = "http://lrlz.sinaapp.com/lrlz?uri=" + encodeURIComponent((window.location.href + "#").substring(0, (window.location.href + "#").indexOf('#'))) + "&callback=";
        this.getJSONP(this.url, function (data) {
            let timestamp = data.timestamp,
                nonceStr = data.nonceStr,
                signature = data.signature,
                appid = data.appid;
            Vue.wechat.config({
                debug: false,
                appId: appid,
                timestamp: timestamp,
                nonceStr: nonceStr,
                signature: signature,
                jsApiList: [
                    'checkJsApi',
                    'onMenuShareTimeline',
                    'onMenuShareAppMessage',
                    'onMenuShareQQ',
                    'onMenuShareWeibo',
                    'onMenuShareQZone',
                    'getNetworkType',
                    'hideOptionMenu',
                    'showOptionMenu',
                    'chooseWXPay'
                ]
            });
        });
        this.ready(shareData);
    }

    getJSONP(url, callback) {
        let cn = "callback" + (+new Date()),
            s = document.createElement("script");
        s.type = "text/javascript";
        s.charset = "UTF-8";
        s.src = url + cn;
        let heads = document.head || document.getElementsByTagName('head')[0];
        let sp = heads.appendChild(s);

        setTimeout(function () { //利用计时器 变成异步
            window[cn] = function (data) {
                try {
                    s.onload = s.onreadystatechange = function () {
                        callback && callback(data);
                    }
                }
                catch (e) {
                }
                finally {
                    setTimeout(function () {
                        if (heads && s.parentNode) {
                            sp.parentNode.removeChild(sp);   //最重销毁
                        }
                        window[cn] = null;
                    }, 3000);
                }
            };
        }, 0);
    }

    ready(data) {
        Vue.wechat.ready(function () {
            //分享朋友圈  / 2.2 监听“分享到朋友圈”按钮点击、自定义分享内容及分享结果接口
            Vue.wechat.onMenuShareTimeline({
                title: data.title, // 分享标
                desc: data.desc,
                link: data.link,    //cookie读取
                imgUrl: data.img,// 分享图标
                trigger: function (res) { 	// 不要尝试在trigger中使用ajax异步请求修改本次分享的内容，因为客户端分享操作是一个同步操作，这时候使用ajax的回包会还没有返回
                },
                success: function (res) {
                },
                cancel: function (res) {
                    //alert('已取消'+res);
                },
                fail: function (res) {
                    //alert(JSON.stringify(res));
                }
            });

            //分享给好友
            Vue.wechat.onMenuShareAppMessage({
                title: data.title, // 分享标
                desc: data.desc,
                link: data.link,    //cookie读取
                imgUrl: data.img,// 分享图标
                trigger: function (res) {
                    // 不要尝试在trigger中使用ajax异步请求修改本次分享的内容，因为客户端分享操作是一个同步操作，这时候使用ajax的回包会还没有返回
                },
                success: function (res) {
                }
            });

            Vue.wechat.error(function (res) {
                alert(res.errMsg);
            });
        })
    }

}


export default WechatShare;